<?php

namespace addons\ygpay;

use addons\ygpay\library\Service;
use think\Addons;
use think\Loader;

/**
 * 插件
 */
class Ygpay extends Addons
{

    /**
     * 插件安装方法
     * @return bool
     */
    public function install()
    {
        
        return true;
    }

    /**
     * 插件卸载方法
     * @return bool
     */
    public function uninstall()
    {
        
        return true;
    }

    /**
     * 插件启用方法
     * @return bool
     */
    public function enable()
    {
        
        return true;
    }

    /**
     * 插件禁用方法
     * @return bool
     */
    public function disable()
    {
        
        return true;
    }

    /**
     * 添加命名空间
     */
    public function appInit()
    {
        Loader::addNamespace('YunGouOS', ADDON_PATH.'ygpay'.DS.'library'.DS.'YunGouOS'.DS);
    }

    /**
     * ask问答插件 订单提交支付行为
     * @throws \think\Exception
     */
    public function askOrderSubmit($order,$extra=null)
    {
        $params = [
            'amount'    => $order['amount'],
            'orderid'   => $order['orderid'],
            'type'      => $order['paytype'],
            'title'     => $order['title'],
            'notifyurl' => isset($extra['notifyurl']) && $extra['notifyurl'] ? $extra['notifyurl'] : addon_url('ygpay/api/ask', [], false, true) . '/type/notify/paytype/' . $order['paytype'],
            'returnurl' => isset($extra['returnurl']) && $extra['returnurl'] ? $extra['returnurl'] : addon_url('ygpay/api/ask', [], false, true) . '/type/return/paytype/' . $order['paytype'],
            'method'    => isset($extra['method'])?$extra['method']:'web',
            'openid'    => isset($extra['openid'])?$extra['openid']:'',
        ];

        $response = Service::submitOrder($params);
        return $response;
    }
}
