<?php

namespace addons\ygpay\controller;

use addons\ygpay\library\Service;
use think\addons\Controller;
use think\Exception;
use YunGouOS\util\PaySign;

class Index extends Controller
{
    protected $layout = 'default';

    protected $config = [];

    public function _initialize()
    {
        parent::_initialize();
        if (!config("app_debug")) {
            $this->error("仅在开发环境下查看");
        }
    }

    public function index()
    {
        $this->view->assign("title", "个人微信支付宝支付插件");
        return $this->view->fetch();
    }

    /**
     * 体验，仅供开发测试
     * @throws \think\Exception
     */
    public function experience()
    {
        $amount = $this->request->request('amount');
        $type = $this->request->request('type');
        $method = $this->request->request('method');

        if (!$amount || $amount < 0) {
            $this->error("支付金额必须大于0");
        }

        if (!$type || !in_array($type, ['alipay', 'wechat'])) {
            $this->error("支付类型不能为空");
        }

        //订单号
        $out_trade_no = date("YmdHis") . mt_rand(100000, 999999);

        //订单标题
        $title = '测试订单';

        //回调链接
        $notifyurl = $this->request->root(true) . '/addons/ygpay/index/notifyx/paytype/' . $type;
        $returnurl = $this->request->root(true) . '/addons/ygpay/index/returnx/paytype/' . $type . '/out_trade_no/' . $out_trade_no;

        $response = Service::submitOrder($amount, $out_trade_no, $type, $title, $notifyurl, $returnurl, $method);

        return $response;
    }

    /**
     * 支付成功，仅供开发测试
     */
    public function notifyx()
    {
        $paytype = $this->request->param('paytype');
        $data = $this->request->request('', null, 'trim');
        $config = Service::getConfig($paytype);
        $key=$config[$paytype]['key'];
        $paySign = new PaySign();
        $result=$paySign->checkNotifySign($data,$key);
        if(!$result){
            echo '签名错误';
            return;
        }

        //你可以在这里你的业务处理逻辑,比如处理你的订单状态、给会员加余额等等功能
        //下面这句必须要执行,且在此之前不能有任何输出
        echo 'SUCCESS';
        return;
    }

    /**
     * 支付返回，仅供开发测试
     */
    public function returnx()
    {
        //你可以在这里通过out_trade_no去验证订单状态
        //但是不可以在此编写订单逻辑！！！
        $this->redirect(addon_url("ygpay/index/index"));
    }

}
